(define window-samples
 (lambda ()
  (let ((wl (left-sample))
        (wr (right-sample)))
   (samples wl (+ 1 (- wr wl))))))

(define autocorrelation
 (lambda ()
  (let* ((data (window-samples))
         (len (length data))
	 (pow2 (ceiling (/ (log len) (log 2))))
	 (fftlen (inexact->exact (expt 2 pow2)))
	 (fftscale (/ 1.0 fftlen))
	 (rl (make-vector fftlen))
	 (im (make-vector fftlen)))
    (do ((i 0 (1+ i))) ((= i fftlen)) (vector-set! rl i 0.0) (vector-set! im i 0.0))
    (do ((i 0 (1+ i))) ((= i len)) (vector-set! rl i (vector-ref data i)))
    (fft rl im 1)
    (do ((i 0 (1+ i))) ((= i fftlen))
      (let ((tempr (vector-ref rl i))
	    (tempi (vector-ref im i)))
	(vector-set! rl i (+ (* tempr tempr) (* tempi tempi)))
	(vector-set! im i 0.0)))
    (fft rl im -1)
    (do ((i 0 (1+ i))) ((= i len)) (vector-set! data i (* (vector-ref rl i) fftscale)))
    (graph data "lag time" 0 len))))

(set! graph-hook "(autocorrelation)")
